#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define ll long long

vector<vector<ll>> g;
vector<char> c;

void f(ll p, ll h) {
    c[p] = 1;
    if (h == 0) return;
    for (ll i = 0; i < g[p].size(); ++i) {
        f(g[p][i], h - 1);
    }
}

int main() {
    ll n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1, vector<ll>());
    c.resize(n + 1, 0);

    ll a, b;
    for (ll i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    for (ll i = 0; i < k; ++i) {
        ll p, h;
        cin >> p >> h;
        f(p, h);
    }

    vector<ll> ans;
    for (ll i = 1; i <= n; ++i) {
        if (c[i] == 1) {
            ans.push_back(i);
        }
    }

    cout << ans.size();
    for (ll i : ans) {
        cout << i << ' ';
    }

    return 0;
}
