#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <map>
using namespace std;
#define ll int

vector<vector<ll>> g;
vector<ll> c;
vector<ll> last;

void f(ll p, ll h) {
    if (h < c[p]) return;
    c[p] = h + 1;
    if (h == 0) {
        last.push_back(p);
        return;
    }
    for (ll i = 0; i < g[p].size(); ++i) {
        f(g[p][i], h - 1);
    }
    g[p] = last;
}

int main() {
//    ifstream cin("input.txt");

    ll n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1, vector<ll>());
    c.resize(n + 1, 0);

    ll a, b;
    for (ll i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    vector<ll> z(n + 1, -1);
    for (ll i = 0; i < k; ++i) {
        ll p, h;
        cin >> p >> h;
        if (z[p] < h) {
            z[p] = h;
        }
    }

    for (ll i = 1; i <= n; ++i) {
        last = vector<ll>();
        f(i, z[i]);
    }

    vector<ll> ans;
    for (ll i = 1; i <= n; ++i) {
        if (c[i] > 0) {
            ans.push_back(i);
        }
    }

    cout << ans.size() << endl;
    for (ll i : ans) {
        cout << i << ' ';
    }

    return 0;
}
