#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
using namespace std;
#define ll long long

vector<vector<ll>> g;
vector<ll> c;

void f(ll p, ll h) {
    if (h < c[p]) return;
    c[p] = h + 1;
    if (h == 0) return;
    for (ll i = 0; i < g[p].size(); ++i) {
        f(g[p][i], h - 1);
    }
}

int main() {
//    ifstream cin("input.txt");

    ll n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1, vector<ll>());
    c.resize(n + 1, 0);

    ll a, b;
    for (ll i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    vector<pair<ll, ll>> z(k);
    for (ll i = 0; i < k; ++i) {
        cin >> z[i].first >> z[i].second;
    }

    sort(z.begin(), z.end(), [](pair<ll, ll> a, pair<ll, ll> b) {
        return a.second > b.second;
    });

    for (auto i : z) {
        f(i.first, i.second);
    }

    vector<ll> ans;
    for (ll i = 1; i <= n; ++i) {
        if (c[i] > 0) {
            ans.push_back(i);
        }
    }

    cout << ans.size() << endl;
    for (ll i : ans) {
        cout << i << ' ';
    }

    return 0;
}
